--- a/drivers/scsi/FlashPoint.c
+++ b/drivers/scsi/FlashPoint.c
@@ -7776,48 +7206,47 @@ static UCHAR FPT_queueFindSccb(PSCCB p_S
  *
  *---------------------------------------------------------------------*/
 
-static void  FPT_utilUpdateResidual(PSCCB p_SCCB)
+static void FPT_utilUpdateResidual(struct sccb *p_SCCB)
 {
-   ULONG partial_cnt;
-   UINT  sg_index;
-   ULONG *sg_ptr;
+	unsigned long partial_cnt;
+	unsigned int sg_index;
+	unsigned long *sg_ptr;
 
-   if (p_SCCB->Sccb_XferState & F_ALL_XFERRED) {
+	if (p_SCCB->Sccb_XferState & F_ALL_XFERRED) {
 
-	  p_SCCB->DataLength = 0x0000;
-	  }
+		p_SCCB->DataLength = 0x0000;
+	}
 
-   else if (p_SCCB->Sccb_XferState & F_SG_XFER) {
+	else if (p_SCCB->Sccb_XferState & F_SG_XFER) {
 
-		 partial_cnt = 0x0000;
+		partial_cnt = 0x0000;
 
-		 sg_index = p_SCCB->Sccb_sgseg;
+		sg_index = p_SCCB->Sccb_sgseg;
 
-		 sg_ptr = (ULONG *)p_SCCB->DataPointer;
+		sg_ptr = (unsigned long *)p_SCCB->DataPointer;
 
-		 if (p_SCCB->Sccb_SGoffset) {
+		if (p_SCCB->Sccb_SGoffset) {
 
 			partial_cnt = p_SCCB->Sccb_SGoffset;
 			sg_index++;
-			}
+		}
 
-		 while ( ((ULONG)sg_index * (ULONG)SG_ELEMENT_SIZE) <
-			p_SCCB->DataLength ) {
+		while (((unsigned long)sg_index *
+			(unsigned long)SG_ELEMENT_SIZE) < p_SCCB->DataLength) {
 
-			partial_cnt += *(sg_ptr+(sg_index * 2));
+			partial_cnt += *(sg_ptr + (sg_index * 2));
 			sg_index++;
-			}
+		}
 
-		 p_SCCB->DataLength = partial_cnt;
-		 }
+		p_SCCB->DataLength = partial_cnt;
+	}
 
-	  else {
+	else {
 
-		 p_SCCB->DataLength -= p_SCCB->Sccb_ATC;
-		 }
+		p_SCCB->DataLength -= p_SCCB->Sccb_ATC;
+	}
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: Wait 1 Second
@@ -7826,23 +7255,22 @@ static void  FPT_utilUpdateResidual(PSCC
  *
  *---------------------------------------------------------------------*/
 
-static void FPT_Wait1Second(ULONG p_port)
+static void FPT_Wait1Second(unsigned long p_port)
 {
-   UCHAR i;
+	unsigned char i;
 
-   for(i=0; i < 4; i++) {
+	for (i = 0; i < 4; i++) {
 
-	  FPT_Wait(p_port, TO_250ms);
+		FPT_Wait(p_port, TO_250ms);
 
-	  if ((RD_HARPOON(p_port+hp_scsictrl_0) & SCSI_RST))
-		 break;
+		if ((RD_HARPOON(p_port + hp_scsictrl_0) & SCSI_RST))
+			break;
 
-	  if((RDW_HARPOON((p_port+hp_intstat)) & SCAM_SEL))
-		 break;
-	  }
+		if ((RDW_HARPOON((p_port + hp_intstat)) & SCAM_SEL))
+			break;
+	}
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: FPT_Wait
@@ -7851,45 +7279,43 @@ static void FPT_Wait1Second(ULONG p_port
  *
  *---------------------------------------------------------------------*/
 
-static void FPT_Wait(ULONG p_port, UCHAR p_delay)
+static void FPT_Wait(unsigned long p_port, unsigned char p_delay)
 {
-   UCHAR old_timer;
-   UCHAR green_flag;
+	unsigned char old_timer;
+	unsigned char green_flag;
 
-   old_timer = RD_HARPOON(p_port+hp_seltimeout);
+	old_timer = RD_HARPOON(p_port + hp_seltimeout);
 
-   green_flag=RD_HARPOON(p_port+hp_clkctrl_0);
-   WR_HARPOON(p_port+hp_clkctrl_0, CLKCTRL_DEFAULT);
+	green_flag = RD_HARPOON(p_port + hp_clkctrl_0);
+	WR_HARPOON(p_port + hp_clkctrl_0, CLKCTRL_DEFAULT);
 
-   WR_HARPOON(p_port+hp_seltimeout,p_delay);
-   WRW_HARPOON((p_port+hp_intstat), TIMEOUT);
-   WRW_HARPOON((p_port+hp_intena), (FPT_default_intena & ~TIMEOUT));
+	WR_HARPOON(p_port + hp_seltimeout, p_delay);
+	WRW_HARPOON((p_port + hp_intstat), TIMEOUT);
+	WRW_HARPOON((p_port + hp_intena), (FPT_default_intena & ~TIMEOUT));
 
+	WR_HARPOON(p_port + hp_portctrl_0,
+		   (RD_HARPOON(p_port + hp_portctrl_0) | START_TO));
 
-   WR_HARPOON(p_port+hp_portctrl_0,
-	  (RD_HARPOON(p_port+hp_portctrl_0) | START_TO));
+	while (!(RDW_HARPOON((p_port + hp_intstat)) & TIMEOUT)) {
 
-   while (!(RDW_HARPOON((p_port+hp_intstat)) & TIMEOUT)) {
+		if ((RD_HARPOON(p_port + hp_scsictrl_0) & SCSI_RST))
+			break;
 
-	  if ((RD_HARPOON(p_port+hp_scsictrl_0) & SCSI_RST))
-		 break;
-
-	  if ((RDW_HARPOON((p_port+hp_intstat)) & SCAM_SEL))
-		 break;
-	  }
+		if ((RDW_HARPOON((p_port + hp_intstat)) & SCAM_SEL))
+			break;
+	}
 
-   WR_HARPOON(p_port+hp_portctrl_0,
-	  (RD_HARPOON(p_port+hp_portctrl_0) & ~START_TO));
+	WR_HARPOON(p_port + hp_portctrl_0,
+		   (RD_HARPOON(p_port + hp_portctrl_0) & ~START_TO));
 
-   WRW_HARPOON((p_port+hp_intstat), TIMEOUT);
-   WRW_HARPOON((p_port+hp_intena), FPT_default_intena);
+	WRW_HARPOON((p_port + hp_intstat), TIMEOUT);
+	WRW_HARPOON((p_port + hp_intena), FPT_default_intena);
 
-   WR_HARPOON(p_port+hp_clkctrl_0,green_flag);
+	WR_HARPOON(p_port + hp_clkctrl_0, green_flag);
 
-   WR_HARPOON(p_port+hp_seltimeout,old_timer);
+	WR_HARPOON(p_port + hp_seltimeout, old_timer);
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: Enable/Disable Write to EEPROM
@@ -7899,26 +7325,26 @@ static void FPT_Wait(ULONG p_port, UCHAR
  *
  *---------------------------------------------------------------------*/
 
-static void FPT_utilEEWriteOnOff(ULONG p_port,UCHAR p_mode)
+static void FPT_utilEEWriteOnOff(unsigned long p_port, unsigned char p_mode)
 {
-   UCHAR ee_value;
-
-   ee_value = (UCHAR)(RD_HARPOON(p_port+hp_ee_ctrl) & (EXT_ARB_ACK | SCSI_TERM_ENA_H));
+	unsigned char ee_value;
 
-   if (p_mode)
+	ee_value =
+	    (unsigned char)(RD_HARPOON(p_port + hp_ee_ctrl) &
+			    (EXT_ARB_ACK | SCSI_TERM_ENA_H));
 
-	  FPT_utilEESendCmdAddr(p_port, EWEN, EWEN_ADDR);
+	if (p_mode)
 
-   else
+		FPT_utilEESendCmdAddr(p_port, EWEN, EWEN_ADDR);
 
+	else
 
-	  FPT_utilEESendCmdAddr(p_port, EWDS, EWDS_ADDR);
+		FPT_utilEESendCmdAddr(p_port, EWDS, EWDS_ADDR);
 
-   WR_HARPOON(p_port+hp_ee_ctrl, (ee_value | SEE_MS)); /*Turn off CS */
-   WR_HARPOON(p_port+hp_ee_ctrl, ee_value);       /*Turn off Master Select */
+	WR_HARPOON(p_port + hp_ee_ctrl, (ee_value | SEE_MS));	/*Turn off CS */
+	WR_HARPOON(p_port + hp_ee_ctrl, ee_value);	/*Turn off Master Select */
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: Write EEPROM
@@ -7928,46 +7354,46 @@ static void FPT_utilEEWriteOnOff(ULONG p
  *
  *---------------------------------------------------------------------*/
 
-static void FPT_utilEEWrite(ULONG p_port, USHORT ee_data, USHORT ee_addr)
+static void FPT_utilEEWrite(unsigned long p_port, unsigned short ee_data,
+			    unsigned short ee_addr)
 {
 
-   UCHAR ee_value;
-   USHORT i;
-
-   ee_value = (UCHAR)((RD_HARPOON(p_port+hp_ee_ctrl) & (EXT_ARB_ACK | SCSI_TERM_ENA_H))|
-		   (SEE_MS | SEE_CS));
-
-
+	unsigned char ee_value;
+	unsigned short i;
 
-   FPT_utilEESendCmdAddr(p_port, EE_WRITE, ee_addr);
+	ee_value =
+	    (unsigned
+	     char)((RD_HARPOON(p_port + hp_ee_ctrl) &
+		    (EXT_ARB_ACK | SCSI_TERM_ENA_H)) | (SEE_MS | SEE_CS));
 
+	FPT_utilEESendCmdAddr(p_port, EE_WRITE, ee_addr);
 
-   ee_value |= (SEE_MS + SEE_CS);
+	ee_value |= (SEE_MS + SEE_CS);
 
-   for(i = 0x8000; i != 0; i>>=1) {
+	for (i = 0x8000; i != 0; i >>= 1) {
 
-	  if (i & ee_data)
-	 ee_value |= SEE_DO;
-	  else
-	 ee_value &= ~SEE_DO;
-
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  ee_value |= SEE_CLK;          /* Clock  data! */
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  ee_value &= ~SEE_CLK;
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  }
-   ee_value &= (EXT_ARB_ACK | SCSI_TERM_ENA_H);
-   WR_HARPOON(p_port+hp_ee_ctrl, (ee_value | SEE_MS));
-
-   FPT_Wait(p_port, TO_10ms);
+		if (i & ee_data)
+			ee_value |= SEE_DO;
+		else
+			ee_value &= ~SEE_DO;
 
-   WR_HARPOON(p_port+hp_ee_ctrl, (ee_value | SEE_MS | SEE_CS)); /* Set CS to EEPROM */
-   WR_HARPOON(p_port+hp_ee_ctrl, (ee_value | SEE_MS));       /* Turn off CS */
-   WR_HARPOON(p_port+hp_ee_ctrl, ee_value);       /* Turn off Master Select */
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		ee_value |= SEE_CLK;	/* Clock  data! */
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		ee_value &= ~SEE_CLK;
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+	}
+	ee_value &= (EXT_ARB_ACK | SCSI_TERM_ENA_H);
+	WR_HARPOON(p_port + hp_ee_ctrl, (ee_value | SEE_MS));
+
+	FPT_Wait(p_port, TO_10ms);
+
+	WR_HARPOON(p_port + hp_ee_ctrl, (ee_value | SEE_MS | SEE_CS));	/* Set CS to EEPROM */
+	WR_HARPOON(p_port + hp_ee_ctrl, (ee_value | SEE_MS));	/* Turn off CS */
+	WR_HARPOON(p_port + hp_ee_ctrl, ee_value);	/* Turn off Master Select */
 }
 
 /*---------------------------------------------------------------------
@@ -7979,25 +7405,25 @@ static void FPT_utilEEWrite(ULONG p_port
  *
  *---------------------------------------------------------------------*/
 
-static USHORT FPT_utilEERead(ULONG p_port, USHORT ee_addr)
+static unsigned short FPT_utilEERead(unsigned long p_port,
+				     unsigned short ee_addr)
 {
-   USHORT i, ee_data1, ee_data2;
+	unsigned short i, ee_data1, ee_data2;
 
 	i = 0;
 	ee_data1 = FPT_utilEEReadOrg(p_port, ee_addr);
-	do
-	{
+	do {
 		ee_data2 = FPT_utilEEReadOrg(p_port, ee_addr);
 
-		if(ee_data1 == ee_data2)
-			return(ee_data1);
+		if (ee_data1 == ee_data2)
+			return ee_data1;
 
 		ee_data1 = ee_data2;
 		i++;
 
-	}while(i < 4);
+	} while (i < 4);
 
-	return(ee_data1);
+	return ee_data1;
 }
 
 /*---------------------------------------------------------------------
@@ -8009,45 +7435,45 @@ static USHORT FPT_utilEERead(ULONG p_por
  *
  *---------------------------------------------------------------------*/
 
-static USHORT FPT_utilEEReadOrg(ULONG p_port, USHORT ee_addr)
+static unsigned short FPT_utilEEReadOrg(unsigned long p_port,
+					unsigned short ee_addr)
 {
 
-   UCHAR ee_value;
-   USHORT i, ee_data;
+	unsigned char ee_value;
+	unsigned short i, ee_data;
 
-   ee_value = (UCHAR)((RD_HARPOON(p_port+hp_ee_ctrl) & (EXT_ARB_ACK | SCSI_TERM_ENA_H))|
-		   (SEE_MS | SEE_CS));
+	ee_value =
+	    (unsigned
+	     char)((RD_HARPOON(p_port + hp_ee_ctrl) &
+		    (EXT_ARB_ACK | SCSI_TERM_ENA_H)) | (SEE_MS | SEE_CS));
 
+	FPT_utilEESendCmdAddr(p_port, EE_READ, ee_addr);
 
-   FPT_utilEESendCmdAddr(p_port, EE_READ, ee_addr);
+	ee_value |= (SEE_MS + SEE_CS);
+	ee_data = 0;
 
+	for (i = 1; i <= 16; i++) {
 
-   ee_value |= (SEE_MS + SEE_CS);
-   ee_data = 0;
+		ee_value |= SEE_CLK;	/* Clock  data! */
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		ee_value &= ~SEE_CLK;
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
 
-   for(i = 1; i <= 16; i++) {
+		ee_data <<= 1;
 
-	  ee_value |= SEE_CLK;          /* Clock  data! */
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  ee_value &= ~SEE_CLK;
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-
-	  ee_data <<= 1;
-
-	  if (RD_HARPOON(p_port+hp_ee_ctrl) & SEE_DI)
-		 ee_data |= 1;
-	  }
+		if (RD_HARPOON(p_port + hp_ee_ctrl) & SEE_DI)
+			ee_data |= 1;
+	}
 
-   ee_value &= ~(SEE_MS + SEE_CS);
-   WR_HARPOON(p_port+hp_ee_ctrl, (ee_value | SEE_MS)); /*Turn off CS */
-   WR_HARPOON(p_port+hp_ee_ctrl, ee_value);   /*Turn off Master Select */
+	ee_value &= ~(SEE_MS + SEE_CS);
+	WR_HARPOON(p_port + hp_ee_ctrl, (ee_value | SEE_MS));	/*Turn off CS */
+	WR_HARPOON(p_port + hp_ee_ctrl, ee_value);	/*Turn off Master Select */
 
-   return(ee_data);
+	return ee_data;
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: Send EE command and Address to the EEPROM
@@ -8057,101 +7483,95 @@ static USHORT FPT_utilEEReadOrg(ULONG p_
  *
  *---------------------------------------------------------------------*/
 
-static void FPT_utilEESendCmdAddr(ULONG p_port, UCHAR ee_cmd, USHORT ee_addr)
+static void FPT_utilEESendCmdAddr(unsigned long p_port, unsigned char ee_cmd,
+				  unsigned short ee_addr)
 {
-   UCHAR ee_value;
-   UCHAR narrow_flg;
+	unsigned char ee_value;
+	unsigned char narrow_flg;
 
-   USHORT i;
+	unsigned short i;
 
+	narrow_flg =
+	    (unsigned char)(RD_HARPOON(p_port + hp_page_ctrl) &
+			    NARROW_SCSI_CARD);
 
-   narrow_flg= (UCHAR)(RD_HARPOON(p_port+hp_page_ctrl) & NARROW_SCSI_CARD);
+	ee_value = SEE_MS;
+	WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
 
+	ee_value |= SEE_CS;	/* Set CS to EEPROM */
+	WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
 
-   ee_value = SEE_MS;
-   WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
+	for (i = 0x04; i != 0; i >>= 1) {
 
-   ee_value |= SEE_CS;                             /* Set CS to EEPROM */
-   WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-
-
-   for(i = 0x04; i != 0; i>>=1) {
-
-	  if (i & ee_cmd)
-		 ee_value |= SEE_DO;
-	  else
-		 ee_value &= ~SEE_DO;
+		if (i & ee_cmd)
+			ee_value |= SEE_DO;
+		else
+			ee_value &= ~SEE_DO;
 
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  ee_value |= SEE_CLK;                         /* Clock  data! */
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  ee_value &= ~SEE_CLK;
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  }
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		ee_value |= SEE_CLK;	/* Clock  data! */
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		ee_value &= ~SEE_CLK;
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+	}
 
+	if (narrow_flg)
+		i = 0x0080;
 
-   if (narrow_flg)
-	  i = 0x0080;
+	else
+		i = 0x0200;
 
-   else
-	  i = 0x0200;
+	while (i != 0) {
 
+		if (i & ee_addr)
+			ee_value |= SEE_DO;
+		else
+			ee_value &= ~SEE_DO;
 
-   while (i != 0) {
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		ee_value |= SEE_CLK;	/* Clock  data! */
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		ee_value &= ~SEE_CLK;
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+		WR_HARPOON(p_port + hp_ee_ctrl, ee_value);
+
+		i >>= 1;
+	}
+}
 
-	  if (i & ee_addr)
-		 ee_value |= SEE_DO;
-	  else
-		 ee_value &= ~SEE_DO;
-
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  ee_value |= SEE_CLK;                         /* Clock  data! */
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  ee_value &= ~SEE_CLK;
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-	  WR_HARPOON(p_port+hp_ee_ctrl, ee_value);
-
-	  i >>= 1;
-	  }
-}
-
-static USHORT FPT_CalcCrc16(UCHAR buffer[])
-{
-   USHORT crc=0;
-	int i,j;
-   USHORT ch;
-   for (i=0; i < ID_STRING_LENGTH; i++)
-   {
-      ch = (USHORT) buffer[i];
-	   for(j=0; j < 8; j++)
-	   {
-		   if ((crc ^ ch) & 1)
-            crc = (crc >> 1) ^ CRCMASK;
-		   else
-            crc >>= 1;
-		   ch >>= 1;
-	   }
-   }
-	return(crc);
+static unsigned short FPT_CalcCrc16(unsigned char buffer[])
+{
+	unsigned short crc = 0;
+	int i, j;
+	unsigned short ch;
+	for (i = 0; i < ID_STRING_LENGTH; i++) {
+		ch = (unsigned short)buffer[i];
+		for (j = 0; j < 8; j++) {
+			if ((crc ^ ch) & 1)
+				crc = (crc >> 1) ^ CRCMASK;
+			else
+				crc >>= 1;
+			ch >>= 1;
+		}
+	}
+	return crc;
 }
 
-static UCHAR FPT_CalcLrc(UCHAR buffer[])
+static unsigned char FPT_CalcLrc(unsigned char buffer[])
 {
 	int i;
-	UCHAR lrc;
+	unsigned char lrc;
 	lrc = 0;
-	for(i = 0; i < ID_STRING_LENGTH; i++)
+	for (i = 0; i < ID_STRING_LENGTH; i++)
 		lrc ^= buffer[i];
-	return(lrc);
+	return lrc;
 }
 
-
-
 /*
   The following inline definitions avoid type conflicts.
 */
@@ -8159,51 +7579,49 @@ static UCHAR FPT_CalcLrc(UCHAR buffer[])
 static inline unsigned char
 FlashPoint__ProbeHostAdapter(struct FlashPoint_Info *FlashPointInfo)
 {
-  return FlashPoint_ProbeHostAdapter((PSCCBMGR_INFO) FlashPointInfo);
+	return FlashPoint_ProbeHostAdapter((struct sccb_mgr_info *)
+					   FlashPointInfo);
 }
 
-
 static inline FlashPoint_CardHandle_T
 FlashPoint__HardwareResetHostAdapter(struct FlashPoint_Info *FlashPointInfo)
 {
-  return FlashPoint_HardwareResetHostAdapter((PSCCBMGR_INFO) FlashPointInfo);
+	return FlashPoint_HardwareResetHostAdapter((struct sccb_mgr_info *)
+						   FlashPointInfo);
 }
 
 static inline void
 FlashPoint__ReleaseHostAdapter(FlashPoint_CardHandle_T CardHandle)
 {
-  FlashPoint_ReleaseHostAdapter(CardHandle);
+	FlashPoint_ReleaseHostAdapter(CardHandle);
 }
 
-
 static inline void
-FlashPoint__StartCCB(FlashPoint_CardHandle_T CardHandle, struct BusLogic_CCB *CCB)
+FlashPoint__StartCCB(FlashPoint_CardHandle_T CardHandle,
+		     struct BusLogic_CCB *CCB)
 {
-  FlashPoint_StartCCB(CardHandle, (PSCCB) CCB);
+	FlashPoint_StartCCB(CardHandle, (struct sccb *)CCB);
 }
 
-
 static inline void
-FlashPoint__AbortCCB(FlashPoint_CardHandle_T CardHandle, struct BusLogic_CCB *CCB)
+FlashPoint__AbortCCB(FlashPoint_CardHandle_T CardHandle,
+		     struct BusLogic_CCB *CCB)
 {
-  FlashPoint_AbortCCB(CardHandle, (PSCCB) CCB);
+	FlashPoint_AbortCCB(CardHandle, (struct sccb *)CCB);
 }
 
-
 static inline boolean
 FlashPoint__InterruptPending(FlashPoint_CardHandle_T CardHandle)
 {
-  return FlashPoint_InterruptPending(CardHandle);
+	return FlashPoint_InterruptPending(CardHandle);
 }
 
-
 static inline int
 FlashPoint__HandleInterrupt(FlashPoint_CardHandle_T CardHandle)
 {
-  return FlashPoint_HandleInterrupt(CardHandle);
+	return FlashPoint_HandleInterrupt(CardHandle);
 }
 
-
 #define FlashPoint_ProbeHostAdapter	    FlashPoint__ProbeHostAdapter
 #define FlashPoint_HardwareResetHostAdapter FlashPoint__HardwareResetHostAdapter
 #define FlashPoint_ReleaseHostAdapter	    FlashPoint__ReleaseHostAdapter
@@ -8212,9 +7630,7 @@ FlashPoint__HandleInterrupt(FlashPoint_C
 #define FlashPoint_InterruptPending	    FlashPoint__InterruptPending
 #define FlashPoint_HandleInterrupt	    FlashPoint__HandleInterrupt
 
-
-#else  /* CONFIG_SCSI_OMIT_FLASHPOINT */
-
+#else				/* CONFIG_SCSI_OMIT_FLASHPOINT */
 
 /*
   Define prototypes for the FlashPoint SCCB Manager Functions.
@@ -8222,12 +7638,11 @@ FlashPoint__HandleInterrupt(FlashPoint_C
 
 extern unsigned char FlashPoint_ProbeHostAdapter(struct FlashPoint_Info *);
 extern FlashPoint_CardHandle_T
-       FlashPoint_HardwareResetHostAdapter(struct FlashPoint_Info *);
+FlashPoint_HardwareResetHostAdapter(struct FlashPoint_Info *);
 extern void FlashPoint_StartCCB(FlashPoint_CardHandle_T, struct BusLogic_CCB *);
 extern int FlashPoint_AbortCCB(FlashPoint_CardHandle_T, struct BusLogic_CCB *);
 extern boolean FlashPoint_InterruptPending(FlashPoint_CardHandle_T);
 extern int FlashPoint_HandleInterrupt(FlashPoint_CardHandle_T);
 extern void FlashPoint_ReleaseHostAdapter(FlashPoint_CardHandle_T);
 
-
-#endif /* CONFIG_SCSI_OMIT_FLASHPOINT */
+#endif				/* CONFIG_SCSI_OMIT_FLASHPOINT */
--- a/drivers/scsi/a100u2w.c
+++ b/drivers/scsi/a100u2w.c
@@ -89,6 +89,7 @@
 #include <linux/string.h>
 #include <linux/ioport.h>
 #include <linux/slab.h>
+#include <linux/dma-mapping.h>
 
 #include <asm/io.h>
 #include <asm/irq.h>
@@ -1052,7 +1053,7 @@ static int __devinit inia100_probe_one(s
 
 	if (pci_enable_device(pdev))
 		goto out;
-	if (pci_set_dma_mask(pdev, 0xffffffffULL)) {
+	if (pci_set_dma_mask(pdev, DMA_32BIT_MASK)) {
 		printk(KERN_WARNING "Unable to set 32bit DMA "
 				    "on inia100 adapter, ignoring.\n");
 		goto out_disable_device;
--- a/drivers/scsi/ahci.c
+++ b/drivers/scsi/ahci.c
@@ -793,7 +793,7 @@ static int ahci_host_init(struct ata_pro
 	void __iomem *mmio = probe_ent->mmio_base;
 	u32 tmp, cap_save;
 	u16 tmp16;
-	unsigned int i, j, using_dac;
+	unsigned int i, using_dac;
 	int rc;
 	void __iomem *port_mmio;
 
@@ -865,6 +865,7 @@ static int ahci_host_init(struct ata_pro
 	}
 
 	for (i = 0; i < probe_ent->n_ports; i++) {
+		unsigned long end_time;
 #if 0 /* BIOSen initialize this incorrectly */
 		if (!(hpriv->port_map & (1 << i)))
 			continue;
@@ -894,13 +895,12 @@ static int ahci_host_init(struct ata_pro
 
 		writel(PORT_CMD_SPIN_UP, port_mmio + PORT_CMD);
 
-		j = 0;
-		while (j < 100) {
+		end_time = jiffies + msecs_to_jiffies(1000);
+		while (time_before(jiffies, end_time)) {
 			msleep(10);
 			tmp = readl(port_mmio + PORT_SCR_STAT);
 			if ((tmp & 0xf) == 0x3)
 				break;
-			j++;
 		}
 
 		tmp = readl(port_mmio + PORT_SCR_ERR);
--- a/drivers/scsi/atp870u.c
+++ b/drivers/scsi/atp870u.c
@@ -28,6 +28,7 @@
 #include <linux/spinlock.h>
 #include <linux/pci.h>
 #include <linux/blkdev.h>
+#include <linux/dma-mapping.h>
 #include <asm/system.h>
 #include <asm/io.h>
 
@@ -2631,7 +2632,7 @@ static int atp870u_probe(struct pci_dev 
 	if (pci_enable_device(pdev))
 		return -EIO;
 
-        if (!pci_set_dma_mask(pdev, 0xFFFFFFFFUL)) {
+        if (!pci_set_dma_mask(pdev, DMA_32BIT_MASK)) {
                 printk(KERN_INFO "atp870u: use 32bit DMA mask.\n");
         } else {
                 printk(KERN_ERR "atp870u: DMA mask required but not available.\n");
--- a/drivers/scsi/dpt_i2o.c
+++ b/drivers/scsi/dpt_i2o.c
@@ -62,6 +62,7 @@ MODULE_DESCRIPTION("Adaptec I2O RAID Dri
 #include <linux/string.h>
 #include <linux/ioport.h>
 #include <linux/mutex.h>
+#include <linux/dma-mapping.h>
 
 #include <asm/processor.h>	/* for boot_cpu_data */
 #include <asm/pgtable.h>
@@ -906,8 +907,8 @@ static int adpt_install_hba(struct scsi_
 	}
 
 	pci_set_master(pDev);
-	if (pci_set_dma_mask(pDev, 0xffffffffffffffffULL) &&
-	    pci_set_dma_mask(pDev, 0xffffffffULL))
+	if (pci_set_dma_mask(pDev, DMA_64BIT_MASK) &&
+	    pci_set_dma_mask(pDev, DMA_32BIT_MASK))
 		return -EINVAL;
 
 	base_addr0_phys = pci_resource_start(pDev,0);
--- a/drivers/scsi/eata.c
+++ b/drivers/scsi/eata.c
@@ -490,6 +490,7 @@
 #include <linux/init.h>
 #include <linux/ctype.h>
 #include <linux/spinlock.h>
+#include <linux/dma-mapping.h>
 #include <asm/byteorder.h>
 #include <asm/dma.h>
 #include <asm/io.h>
@@ -1426,7 +1427,7 @@ static int port_detect(unsigned long por
 
 	if (ha->pdev) {
 		pci_set_master(ha->pdev);
-		if (pci_set_dma_mask(ha->pdev, 0xffffffff))
+		if (pci_set_dma_mask(ha->pdev, DMA_32BIT_MASK))
 			printk("%s: warning, pci_set_dma_mask failed.\n",
 			       ha->board_name);
 	}
--- a/drivers/scsi/gdth.c
+++ b/drivers/scsi/gdth.c
@@ -400,6 +400,7 @@
 #include <linux/spinlock.h>
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0)
 #include <linux/blkdev.h>
+#include <linux/dma-mapping.h>
 #else
 #include <linux/blk.h>
 #include "sd.h"
@@ -4527,15 +4528,15 @@ static int __init gdth_detect(struct scs
             if (!(ha->cache_feat & ha->raw_feat & ha->screen_feat &GDT_64BIT)||
                 /* 64-bit DMA only supported from FW >= x.43 */
                 (!ha->dma64_support)) {
-                if (pci_set_dma_mask(pcistr[ctr].pdev, 0xffffffff)) {
+                if (pci_set_dma_mask(pcistr[ctr].pdev, DMA_32BIT_MASK)) {
                     printk(KERN_WARNING "GDT-PCI %d: Unable to set 32-bit DMA\n", hanum);
                     err = TRUE;
                 }
             } else {
                 shp->max_cmd_len = 16;
-                if (!pci_set_dma_mask(pcistr[ctr].pdev, 0xffffffffffffffffULL)) {
+                if (!pci_set_dma_mask(pcistr[ctr].pdev, DMA_64BIT_MASK)) {
                     printk("GDT-PCI %d: 64-bit DMA enabled\n", hanum);
-                } else if (pci_set_dma_mask(pcistr[ctr].pdev, 0xffffffff)) {
+                } else if (pci_set_dma_mask(pcistr[ctr].pdev, DMA_32BIT_MASK)) {
                     printk(KERN_WARNING "GDT-PCI %d: Unable to set 64/32-bit DMA\n", hanum);
                     err = TRUE;
                 }
--- a/drivers/scsi/gdth_proc.c
+++ b/drivers/scsi/gdth_proc.c
@@ -3,6 +3,7 @@
  */
 
 #include <linux/completion.h>
+#include <linux/version.h>
 
 #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0)
 int gdth_proc_info(struct Scsi_Host *host, char *buffer,char **start,off_t offset,int length,   
--- a/drivers/scsi/ibmmca.c
+++ b/drivers/scsi/ibmmca.c
@@ -1001,12 +1001,11 @@ static char *ti_p(int dev)
 /* interpreter for logical device numbers (ldn) */
 static char *ti_l(int val)
 {
-	const char hex[16] = "0123456789abcdef";
 	static char answer[2];
 
 	answer[1] = (char) (0x0);
 	if (val <= MAX_LOG_DEV)
-		answer[0] = hex[val];
+		answer[0] = small_digits[val];
 	else
 		answer[0] = '-';
 	return (char *) &answer;
--- a/drivers/scsi/initio.c
+++ b/drivers/scsi/initio.c
@@ -127,6 +127,7 @@
 #include <linux/sched.h>
 #include <linux/slab.h>
 #include <linux/jiffies.h>
+#include <linux/dma-mapping.h>
 #include <asm/io.h>
 
 #include <scsi/scsi.h>
@@ -2780,7 +2781,7 @@ static int tul_NewReturnNumberOfAdapters
 			if (((dRegValue & 0xFF00) >> 8) == 0xFF)
 				dRegValue = 0;
 			wBIOS = (wBIOS << 8) + ((UWORD) ((dRegValue & 0xFF00) >> 8));
-			if (pci_set_dma_mask(pDev, 0xffffffff)) {
+			if (pci_set_dma_mask(pDev, DMA_32BIT_MASK)) {
 				printk(KERN_WARNING 
 				       "i91u: Could not set 32 bit DMA mask\n");
 				continue;
--- a/drivers/scsi/ips.c
+++ b/drivers/scsi/ips.c
@@ -176,7 +176,7 @@
 #include <linux/proc_fs.h>
 #include <linux/reboot.h>
 #include <linux/interrupt.h>
-
+#include <linux/dma-mapping.h>
 #include <linux/blkdev.h>
 #include <linux/types.h>
 
@@ -7282,10 +7282,10 @@ ips_init_phase1(struct pci_dev *pci_dev,
 	 * are guaranteed to be < 4G.
 	 */
 	if (IPS_ENABLE_DMA64 && IPS_HAS_ENH_SGLIST(ha) &&
-	    !pci_set_dma_mask(ha->pcidev, 0xffffffffffffffffULL)) {
+	    !pci_set_dma_mask(ha->pcidev, DMA_64BIT_MASK)) {
 		(ha)->flags |= IPS_HA_ENH_SG;
 	} else {
-		if (pci_set_dma_mask(ha->pcidev, 0xffffffffULL) != 0) {
+		if (pci_set_dma_mask(ha->pcidev, DMA_32BIT_MASK) != 0) {
 			printk(KERN_WARNING "Unable to set DMA Mask\n");
 			return ips_abort_init(ha, index);
 		}
--- a/drivers/scsi/lpfc/lpfc_scsi.c
+++ b/drivers/scsi/lpfc/lpfc_scsi.c
@@ -21,6 +21,7 @@
 
 #include <linux/pci.h>
 #include <linux/interrupt.h>
+#include <linux/delay.h>
 
 #include <scsi/scsi.h>
 #include <scsi/scsi_device.h>
@@ -947,7 +948,7 @@ lpfc_abort_handler(struct scsi_cmnd *cmn
 			lpfc_sli_poll_fcp_ring (phba);
 
 		spin_unlock_irq(phba->host->host_lock);
-			schedule_timeout_uninterruptible(LPFC_ABORT_WAIT*HZ);
+		ssleep(LPFC_ABORT_WAIT);
 		spin_lock_irq(phba->host->host_lock);
 		if (++loop_count
 		    > (2 * phba->cfg_nodev_tmo)/LPFC_ABORT_WAIT)
@@ -1002,7 +1003,7 @@ lpfc_reset_lun_handler(struct scsi_cmnd 
 
 		if (pnode->nlp_state != NLP_STE_MAPPED_NODE) {
 			spin_unlock_irq(phba->host->host_lock);
-			schedule_timeout_uninterruptible(msecs_to_jiffies(500));
+			msleep(500);
 			spin_lock_irq(phba->host->host_lock);
 		}
 		if ((pnode) && (pnode->nlp_state == NLP_STE_MAPPED_NODE))
@@ -1057,7 +1058,7 @@ lpfc_reset_lun_handler(struct scsi_cmnd 
 	loopcnt = 0;
 	while(cnt) {
 		spin_unlock_irq(phba->host->host_lock);
-		schedule_timeout_uninterruptible(LPFC_RESET_WAIT*HZ);
+		ssleep(LPFC_RESET_WAIT);
 		spin_lock_irq(phba->host->host_lock);
 
 		if (++loopcnt
@@ -1162,7 +1163,7 @@ lpfc_reset_bus_handler(struct scsi_cmnd 
 	loopcnt = 0;
 	while(cnt) {
 		spin_unlock_irq(phba->host->host_lock);
-		schedule_timeout_uninterruptible(LPFC_RESET_WAIT*HZ);
+		ssleep(LPFC_RESET_WAIT);
 		spin_lock_irq(phba->host->host_lock);
 
 		if (++loopcnt
--- a/drivers/scsi/megaraid.c
+++ b/drivers/scsi/megaraid.c
@@ -45,6 +45,7 @@
 #include <linux/interrupt.h>
 #include <linux/pci.h>
 #include <linux/init.h>
+#include <linux/dma-mapping.h>
 #include <scsi/scsicam.h>
 
 #include "scsi.h"
@@ -2094,7 +2095,7 @@ make_local_pdev(adapter_t *adapter, stru
 
 	memcpy(*pdev, adapter->dev, sizeof(struct pci_dev));
 
-	if( pci_set_dma_mask(*pdev, 0xffffffff) != 0 ) {
+	if( pci_set_dma_mask(*pdev, DMA_32BIT_MASK) != 0 ) {
 		kfree(*pdev);
 		return -1;
 	}
@@ -4859,10 +4860,10 @@ megaraid_probe_one(struct pci_dev *pdev,
 
 	/* Set the Mode of addressing to 64 bit if we can */
 	if ((adapter->flag & BOARD_64BIT) && (sizeof(dma_addr_t) == 8)) {
-		pci_set_dma_mask(pdev, 0xffffffffffffffffULL);
+		pci_set_dma_mask(pdev, DMA_64BIT_MASK);
 		adapter->has_64bit_addr = 1;
 	} else  {
-		pci_set_dma_mask(pdev, 0xffffffff);
+		pci_set_dma_mask(pdev, DMA_32BIT_MASK);
 		adapter->has_64bit_addr = 0;
 	}
 		
--- a/drivers/scsi/megaraid/megaraid_mbox.c
+++ b/drivers/scsi/megaraid/megaraid_mbox.c
@@ -2768,6 +2768,7 @@ mbox_post_sync_cmd(adapter_t *adapter, u
 	mbox_t		*mbox;
 	uint8_t		status;
 	int		i;
+	unsigned long end_time;
 
 
 	mbox64	= raid_dev->mbox64;
@@ -2799,25 +2800,27 @@ mbox_post_sync_cmd(adapter_t *adapter, u
 	if (mbox->numstatus == 0xFF) {	// status not yet available
 		udelay(25);;
 
-		for (i = 0; mbox->numstatus == 0xFF && i < 1000; i++) {
+		end_time = jiffies + msecs_to_jiffies(1000);
+		while (mbox->numstatus == 0xFF && time_before(jiffies, end_time)) {
 			rmb();
 			msleep(1);
 		}
 
 
-		if (i == 1000) {
+		if (time_after_eq(jiffies, end_time)) {
 			con_log(CL_ANN, (KERN_NOTICE
 				"megaraid mailbox: wait for FW to boot      "));
 
+			end_time = jiffies + msecs_to_jiffies(MBOX_RESET_WAIT * 1000);
 			for (i = 0; (mbox->numstatus == 0xFF) &&
-					(i < MBOX_RESET_WAIT); i++) {
+					time_before(jiffies, end_time); ++i) {
 				rmb();
 				con_log(CL_ANN, ("\b\b\b\b\b[%03d]",
 							MBOX_RESET_WAIT - i));
 				msleep(1000);
 			}
 
-			if (i == MBOX_RESET_WAIT) {
+			if (time_after_eq(jiffies, end_time)) {
 
 				con_log(CL_ANN, (
 				"\nmegaraid mailbox: status not available\n"));
@@ -2832,12 +2835,13 @@ mbox_post_sync_cmd(adapter_t *adapter, u
 	if (mbox->poll != 0x77) {
 		udelay(25);
 
-		for (i = 0; (mbox->poll != 0x77) && (i < 1000); i++) {
+		end_time = jiffies + msecs_to_jiffies(1000);
+		while ((mbox->poll != 0x77) && time_before(jiffies, end_time)) {
 			rmb();
 			msleep(1);
 		}
 
-		if (i == 1000) {
+		if (time_after_eq(jiffies, end_time)) {
 			con_log(CL_ANN, (KERN_WARNING
 			"megaraid mailbox: could not get poll semaphore\n"));
 			return -1;
@@ -2851,12 +2855,13 @@ mbox_post_sync_cmd(adapter_t *adapter, u
 	if (RDINDOOR(raid_dev) & 0x2) {
 		udelay(25);
 
-		for (i = 0; (RDINDOOR(raid_dev) & 0x2) && (i < 1000); i++) {
+		end_time = jiffies + msecs_to_jiffies(1000);
+		while ((RDINDOOR(raid_dev) & 0x2) && time_before(jiffies, end_time)) {
 			rmb();
 			msleep(1);
 		}
 
-		if (i == 1000) {
+		if (time_after_eq(jiffies, end_time)) {
 			con_log(CL_ANN, (KERN_WARNING
 				"megaraid mailbox: could not acknowledge\n"));
 			return -1;
@@ -2947,16 +2952,19 @@ static int
 megaraid_busywait_mbox(mraid_device_t *raid_dev)
 {
 	mbox_t	*mbox = raid_dev->mbox;
-	int	i = 0;
+	unsigned long end_time;
 
 	if (mbox->busy) {
 		udelay(25);
-		for (i = 0; mbox->busy && i < 1000; i++)
+		end_time = jiffies + msecs_to_jiffies(1000);
+		while (mbox->busy && time_before(jiffies, end_time))
 			msleep(1);
 	}
 
-	if (i < 1000) return 0;
-	else return -1;
+	if (mbox->busy)
+		return -1;
+	else
+		return 0;
 }
 
 
